#	Login.cmd for Mnematics, Inc.
#
# Globenet Type 'R' Login Procedure
#
# This script is for Trumpet 2.05B. It may work with other versions.
# It will establish a 'standard' PPP connection using the login
# dialogue. This is the recommended configuration for new and/or
# non-technical users.
#
# NOTE: Enter your password WITHOUT the leading "*" character.
#
# For TIA SLIP or PPP connections, contact your Globenet representative
# or call 914-359-4546. An anonymous FTP server at
#                        ftp://mne.net/pub/scripts/trumpet
# contains scripts currently available.
#
# Note: To establish or change the access phone number,
# pull down the Dialler menu, and choose Setup.cmd. You will be prompted
# for Phone Number, Username, and Password.
#
# Last modified 12/20/95 by GWS
#
# Set up some strings for dialling up
#
if ![load $number]
  if [query $number "Enter the access phone number"]
    save $number
  end
end
if ![load $username]
  if [username "Enter your Subscriber ID"]
    save $username
  end
end
if ![load $password]
  display "E
nter password WITHOUT leading *"\n
  if [password "Enter your login password"]
    save $password
  end
end
#
# Note: &K3 selects CTS/RTS flow control on MOST Hayes compatible modems.
# If this setup string causes an "ERROR" message from your modem, try
# removing the "&K3" and replacing it with the appropriate string for
# your modem
#
$modemsetup = "&C1&D2&K3"
$prompt = "PPP"
$userprompt = "ogin:"
$passprompt = "assword:"
######### $slipcmd = "slip"
$addrtarg = "Your address is"
$pppcmd = "ppp"

%attempts = 10
#
# Initialize user's modem
#
output "atz"\13
if ! [input 10 OK\n]
  display "Modem is not responding"\n
  abort
end
#
# setup our modem commands
#
output "at"$modemsetup\13
input 10 OK\n
#
# send phone number
#
%n = 0
repeat
  if %n = %attempts
    display "Too many dial attempts"\n
    abort
  end
  output "atdt"$number\13
  %ok = [input 60 CONNECT]
  %n = %n + 1
until %ok
input 10 \n
#
#  wait till it's safe to send because some modems hang up
#  if you transmit during the connection phase
#
wait 3
0 dcd
#
# No sleep needed here; no wake-up call needed
# Type 'P' Globenet gateway does not require autobaud.
#
#
#  wait for the username prompt
#
input 30 $userprompt
output $username\13
#
# and the password
#
input 30 $passprompt
output $password\13
#
# PPP protocol begins immediately
#
output $pppcmd\13
#
display "PPP mode selected.  Will try to negotiate IP address."\n
#
# PPP mode begun, or else something is wrong.
#
